MWAWFont Class Reference documentation

Classes | Public Types | Public Member Functions | Public Attributes | Protected Attributes | List of all members
MWAWFont Class Reference

Class to store font. More...

`#include <MWAWFont.hxx>`

## Classes
struct | Line
| a small struct to define a line in MWAWFont More...
struct | Script
| a small struct to define the script position in MWAWFont More...

## Public Types
enum | FontBits { boldBit =1 , italicBit =2 , blinkBit =4 , embossBit =8 , engraveBit =0x10 , hiddenBit =0x20 , outlineBit =0x40 , shadowBit =0x80 , reverseVideoBit =0x100 , smallCapsBit =0x200 , uppercaseBit =0x400 , lowercaseBit =0x800 , initialcaseBit =2*lowercaseBit , boxedBit =2*initialcaseBit , boxedRoundedBit =2*boxedBit , reverseWritingBit =2*boxedRoundedBit }
| the different font bit More...

## Public Member Functions
| MWAWFont (int newId=-1, float sz=12, uint32_t f=0)
| constructor More...
bool | isSet () const
| returns true if the font id is initialized More...
void | insert (MWAWFont const &ft)
| inserts the set value in the current font More...
void | setFont (int newId)
| sets the font id and resets size to the previous size for this font More...
int | id () const
| returns the font id More...
void | setId (int newId)
| sets the font id More...
float | size () const
| returns the font size More...
void | setSize (float sz, bool isRelative=false)
| sets the font size More...
float | deltaLetterSpacing () const
| returns the condensed(negative)/extended(positive) width More...
librevenge::RVNGUnit | deltaLetterSpacingUnit () const
| returns the condensed(negative)/extended(positive) unit More...
void | setDeltaLetterSpacing (float d, librevenge::RVNGUnit unit=librevenge::RVNG_POINT)
| sets the letter spacing ( delta value in point ) More...
float | widthStreching () const
| returns the text width streching More...
void | setWidthStreching (float scale=1.0)
| sets the text width streching More...
Script const & | script () const
| returns the script position More...
void | set (Script const &newscript)
| sets the script position More...
uint32_t | flags () const
| returns the font flags More...
void | setFlags (uint32_t fl)
| sets the font attributes bold, ... More...
bool | hasColor () const
| returns true if the font color is not black More...
void | getColor (MWAWColor &c) const
| returns the font color More...
void | setColor (MWAWColor color)
| sets the font color More...
void | getBackgroundColor (MWAWColor &c) const
| returns the font background color More...
void | setBackgroundColor (MWAWColor color)
| sets the font background color More...
void | resetColor ()
| resets the font color to black and the background color to white More...
bool | hasDecorationLines () const
| return true if the font has decorations line (overline, strikeout, underline) More...
void | resetDecorationLines ()
| reset the decoration More...
Line const & | getOverline () const
| returns the overline More...
void | setOverline (Line const &line)
| sets the overline More...
void | setOverlineStyle (Line::Style style=Line::None, bool doReset=true)
| sets the overline style ( by default, we also reset the style) More...
void | setOverlineType (Line::Type type=Line::Single)
| sets the overline type More...
void | setOverlineWordFlag (bool wordFlag=false)
| sets the overline word flag More...
void | setOverlineWidth (float w)
| sets the overline width More...
void | setOverlineColor (MWAWColor const &color)
| sets the overline color More...
Line const & | getStrikeOut () const
| returns the strikeoutline More...
void | setStrikeOut (Line const &line)
| sets the strikeoutline More...
void | setStrikeOutStyle (Line::Style style=Line::None, bool doReset=true)
| sets the strikeoutline style ( by default, we also reset the style) More...
void | setStrikeOutType (Line::Type type=Line::Single)
| sets the strikeoutline type More...
void | setStrikeOutWordFlag (bool wordFlag=false)
| sets the strikeoutline word flag More...
void | setStrikeOutWidth (float w)
| sets the strikeoutline width More...
void | setStrikeOutColor (MWAWColor const &color)
| sets the strikeoutline color More...
Line const & | getUnderline () const
| returns the underline More...
void | setUnderline (Line const &line)
| sets the underline More...
void | setUnderlineStyle (Line::Style style=Line::None, bool doReset=true)
| sets the underline style ( by default, we also reset the style) More...
void | setUnderlineType (Line::Type type=Line::Single)
| sets the underline type More...
void | setUnderlineWordFlag (bool wordFlag=false)
| sets the underline word flag More...
void | setUnderlineWidth (float w)
| sets the underline width More...
void | setUnderlineColor (MWAWColor const &color)
| sets the underline color More...
std::string const & | language () const
| returns the language More...
void | setLanguage (std::string const &lang)
| set the language ( in the for en_US, en_GB, en, ...) More...
void | addTo (librevenge::RVNGPropertyList &propList, std::shared_ptr< MWAWFontConverter > fontConverter) const
| add to the propList More...
void | addToListLevel (librevenge::RVNGPropertyList &propList, std::shared_ptr< MWAWFontConverter > fontConverter) const
| add to the propList to a list level More...
std::string | getDebugString (std::shared_ptr< MWAWFontConverter > &converter) const
| returns a string which can be used for debugging More...
bool | operator== (MWAWFont const &f) const
| operator== More...
bool | operator!= (MWAWFont const &f) const
| operator!= More...
int | cmp (MWAWFont const &oth) const
| a comparison function More...

## Public Attributes
std::string | m_extra
| extra data More...

## Protected Attributes
MWAWVariable< int > | m_id
| font identificator More...
MWAWVariable< float > | m_size
| font size More...
MWAWVariable< bool > | m_sizeIsRelative
| true if the size is percent More...
MWAWVariable< float > | m_deltaSpacing
| expand(> 0), condensed(< 0) depl More...
MWAWVariable< librevenge::RVNGUnit > | m_deltaSpacingUnit
| the delta spacing unit More...
MWAWVariable< float > | m_widthStreching
| the width streching in percent More...
MWAWVariable< Script > | m_scriptPosition
| the sub/super script definition More...
MWAWVariable< uint32_t > | m_flags
| font attributes More...
MWAWVariable< Line > | m_overline
| overline attributes More...
MWAWVariable< Line > | m_strikeoutline
| overline attributes More...
MWAWVariable< Line > | m_underline
| underline attributes More...
MWAWVariable< MWAWColor > | m_color
| font color More...
MWAWVariable< MWAWColor > | m_backgroundColor
| font background color More...
MWAWVariable< std::string > | m_language
| the language if set More...

## Detailed Description

Class to store font.

## Member Enumeration Documentation

## ◆ FontBits

enum MWAWFont::FontBits

the different font bit

Enumerator
boldBit |
italicBit |
blinkBit |
embossBit |
engraveBit |
hiddenBit |
outlineBit |
shadowBit |
reverseVideoBit |
smallCapsBit |
uppercaseBit |
lowercaseBit |
initialcaseBit |
boxedBit |
boxedRoundedBit |
reverseWritingBit |

## Constructor & Destructor Documentation

## ◆ MWAWFont()

MWAWFont::MWAWFont | ( | int | newId = `-1`,
|  | float | sz = `12`,
|  | uint32_t | f = `0`
| ) |  |
| inlineexplicit

constructor

Parameters

  newId | system id font
  sz | the font size
  f | the font attributes bold, ...

## Member Function Documentation

## ◆ addTo()

void MWAWFont::addTo | ( | librevenge::RVNGPropertyList & | propList,
|  | std::shared_ptr< MWAWFontConverter > | fontConverter
| ) |  | const

add to the propList

Referenced by MWAWCell::addTo().

## ◆ addToListLevel()

void MWAWFont::addToListLevel | ( | librevenge::RVNGPropertyList & | propList,
|  | std::shared_ptr< MWAWFontConverter > | fontConverter
| ) |  | const

add to the propList to a list level

Referenced by MWAWListLevel::addTo().

## ◆ cmp()

int MWAWFont::cmp | ( | MWAWFont const & | oth | ) | const
| inline

a comparison function

Referenced by MsWrdStruct::Font::cmp(), operator!=(), MWAWFontManagerInternal::FontCompare::operator()(), and operator==().

## ◆ deltaLetterSpacing()

float MWAWFont::deltaLetterSpacing | ( |  | ) | const
| inline

returns the condensed(negative)/extended(positive) width

## ◆ deltaLetterSpacingUnit()

librevenge::RVNGUnit MWAWFont::deltaLetterSpacingUnit | ( |  | ) | const
| inline

returns the condensed(negative)/extended(positive) unit

## ◆ flags()

uint32_t MWAWFont::flags | ( |  | ) | const
| inline

returns the font flags

Referenced by cmp(), insert(), LightWayTxtTextInternal::Font::merge(), JazzSSParser::readCell(), MsWrdTextStyles::readFont(), StyleParser::readFormats(), MoreText::readOutline(), FullWrtText::send(), MoreText::sendText(), StudentWritingCParser::sendText(), and MsWrdStruct::Font::updateFontToFinalState().

## ◆ getBackgroundColor()

void MWAWFont::getBackgroundColor | ( | MWAWColor & | c | ) | const
| inline

returns the font background color

Referenced by LightWayTxtTextInternal::Font::merge().

## ◆ getColor()

void MWAWFont::getColor | ( | MWAWColor & | c | ) | const
| inline

returns the font color

Referenced by MarinerWrtGraph::sendRule(), and MoreText::sendText().

## ◆ getDebugString()

std::string MWAWFont::getDebugString | ( | std::shared_ptr< MWAWFontConverter > & | converter | ) | const

returns a string which can be used for debugging

Referenced by ZWrtTextInternal::HFZone::getDebugString(), MsWrdText::prepareData(), BeagleWksSSParser::readCellSheet(), MouseWrtParser::readCharPLCs(), RagTimeText::readCharProperties(), Canvas5StyleManager::readCharStyle(), MacWrtProStructures::readCharStyles(), MoreText::readCustomListLevel(), JazzSSParser::readDocument(), LightWayTxtText::readDocumentHF(), MsWksDBParser::readFieldTypes(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), WordMakerParser::readFont(), MacDocParser::readFont(), MsWks4Text::readFont(), LightWayTxtText::readFont2(), ClarisWksStyleManager::readFontAndPos(), MarinerWrtText::readFonts(), HanMacWrdJText::readFonts(), LightWayTxtText::readFonts(), NisusWrtText::readFonts(), PowerPoint1Parser::readFonts(), MindWrtParser::readFonts(), RagTimeText::readFonts(), MacWrtProStructures::readFontsDef(), MacDrawProStyleManager::readFontStyles(), DocMkrText::readFooter(), BeagleWksDBParser::readFormat(), MsWksDBParser::readFormTypes(), ActaParser::readHFProperties(), MacWrtParser::readInformations(), MacDraftParser::readLabel(), MacDraftParser::readObject(), MacDrawParser::readObject(), MsWrdTextStyles::readPLC(), MsWrd1Parser::readPLC(), ClarisWksDbaseContent::readRecordSSV1(), MsWksDBParser::readReportHeader(), RagTimeSpreadsheet::readResource(), ZWrtText::readSectionFonts(), SuperPaintParser::readShape(), RagTimeSpreadsheet::readSpreadsheetCellFormat(), RagTimeSpreadsheet::readSpreadsheetCellV2(), WingzParser::readSpreadsheetStyle(), BeagleWksDRParser::readStyle(), MacWrtProStructures::readStyle(), GreatWksSSParser::readStyles(), DocMkrText::readStyles(), MaxWrtParser::readStyles(), TeachTxtParser::readStyles(), WriteNowText::readStyles(), MsWrdTextStyles::readStylesFont(), StyleParser::readStyleTable(), MsWksTable::readTable(), MacDraft5Parser::readText(), MacWrtParser::readText(), MsWksGraph::readText(), PowerPoint7Text::readTextZone(), PowerPoint3Parser::readTextZone(), WingzGraph::readTextZone(), ActaText::readTopic(), MsWksDBParser::readUnknownV2(), GreatWksText::readZone(), WriteNowText::send(), Canvas5Graph::sendDimension9(), JazzWriterParser::sendPLC(), DrawTableParser::sendShape(), GreatWksText::sendSimpleTextbox(), ActaText::sendText(), CanvasGraph::sendText(), MsWks3Text::sendText(), PowerPoint1Parser::sendText(), and PowerPoint3Parser::sendText().

## ◆ getOverline()

Line const& MWAWFont::getOverline | ( |  | ) | const
| inline

returns the overline

Referenced by LightWayTxtTextInternal::Font::merge().

## ◆ getStrikeOut()

Line const& MWAWFont::getStrikeOut | ( |  | ) | const
| inline

returns the strikeoutline

Referenced by LightWayTxtTextInternal::Font::merge(), MsWrdTextStyles::readFont(), and MsWrdStruct::Font::updateFontToFinalState().

## ◆ getUnderline()

Line const& MWAWFont::getUnderline | ( |  | ) | const
| inline

returns the underline

Referenced by LightWayTxtTextInternal::Font::merge(), MsWrdTextStyles::readFont(), MarinerWrtText::readFonts(), MoreText::sendText(), and MsWrdStruct::Font::updateFontToFinalState().

## ◆ hasColor()

bool MWAWFont::hasColor | ( |  | ) | const
| inline

returns true if the font color is not black

Referenced by getDebugString().

## ◆ hasDecorationLines()

bool MWAWFont::hasDecorationLines | ( |  | ) | const
| inline

return true if the font has decorations line (overline, strikeout, underline)

## ◆ id()

int MWAWFont::id | ( |  | ) | const
| inline

returns the font id

Referenced by cmp(), getDebugString(), BeagleWksText::getFont(), MsWrdTextStyles::getFont(), PowerPoint3Parser::readParagraph(), MaxWrtParser::readStyles(), MsWks4Text::readText(), PowerPoint7Text::readTextZone(), FullWrtText::send(), Canvas5Graph::sendCurveText(), MoreText::sendText(), MWAWGraphicListener::setFont(), MWAWPresentationListener::setFont(), MWAWSpreadsheetListener::setFont(), MWAWTextListener::setFont(), and MsWrdTextStyles::setProperty().

## ◆ insert()

void MWAWFont::insert | ( | MWAWFont const & | ft | ) |
| inline

inserts the set value in the current font

Referenced by MsWrdStruct::Font::insert().

## ◆ isSet()

bool MWAWFont::isSet | ( |  | ) | const
| inline

returns true if the font id is initialized

Referenced by MWAWFont::Script::str().

## ◆ language()

std::string const& MWAWFont::language | ( |  | ) | const
| inline

returns the language

## ◆ operator!=()

bool MWAWFont::operator!= | ( | MWAWFont const & | f | ) | const
| inline

operator!=

## ◆ operator==()

bool MWAWFont::operator== | ( | MWAWFont const & | f | ) | const
| inline

operator==

## ◆ resetColor()

void MWAWFont::resetColor | ( |  | ) |
| inline

resets the font color to black and the background color to white

Referenced by MWAWFont(), and setFont().

## ◆ resetDecorationLines()

void MWAWFont::resetDecorationLines | ( |  | ) |
| inline

reset the decoration

## ◆ script()

Script const& MWAWFont::script | ( |  | ) | const
| inline

returns the script position

Referenced by cmp(), and LightWayTxtTextInternal::Font::merge().

## ◆ set()

void MWAWFont::set | ( | Script const & | newscript | ) |
| inline

sets the script position

Referenced by BeagleWksTextInternal::Font::getFont(), LightWayTxtTextInternal::Font::merge(), RagTimeText::readCharProperties(), Canvas5StyleManager::readCharStyle(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrd1Parser::readFont(), WordMakerParser::readFont(), MsWks3Text::readFont(), MsWrdTextStyles::readFont(), GreatWksText::readFont(), MsWksGraph::readFont(), PowerPoint3Parser::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MsWks4Text::readFont(), MacWrtProStructures::readFont(), LightWayTxtText::readFont2(), ClarisWksStyleManager::readFontAndPos(), WriterPlsParser::readFonts(), MarinerWrtText::readFonts(), NisusWrtText::readFonts(), MindWrtParser::readFonts(), RagTimeText::readFonts(), MacDrawProStyleManager::readFontStyles(), StyleParser::readFormats(), MacWrtParser::readInformations(), RagTimeSpreadsheet::readResource(), RagTimeSpreadsheet::readSpreadsheetCellV2(), GreatWksSSParser::readStyles(), MsWksTable::readTable(), MacWrtParser::readText(), PowerPoint7Text::readTextZone(), WriteNowText::send(), GreatWksText::sendSimpleTextbox(), CanvasGraph::sendText(), MacDraft5Parser::sendText(), MoreText::sendText(), StudentWritingCParser::sendText(), FullWrtTextInternal::Font::update(), and RagTime5StyleManager::updateTextStyles().

## ◆ setBackgroundColor()

void MWAWFont::setBackgroundColor | ( | MWAWColor | color | ) |
| inline

sets the font background color

Referenced by LightWayTxtTextInternal::Font::merge(), HanMacWrdKText::readFont(), HanMacWrdJText::readFont(), LightWayTxtText::readFont2(), MarinerWrtText::readFonts(), and StyleParser::readFormats().

## ◆ setColor()

void MWAWFont::setColor | ( | MWAWColor | color | ) |
| inline

sets the font color

Referenced by ApplePictParser::drawText(), BeagleWksTextInternal::Font::getFont(), MsWksSSParser::readCell(), BeagleWksSSParser::readCellSheet(), Canvas5StyleManager::readCharStyle(), MoreText::readCustomListLevel(), LightWayTxtText::readDocumentHF(), MsWksDBParser::readFieldTypes(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), WordMakerParser::readFont(), MsWks3Text::readFont(), MsWrdTextStyles::readFont(), MacDocParser::readFont(), GreatWksText::readFont(), MsWksGraph::readFont(), PowerPoint3Parser::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MsWks4Text::readFont(), MacWrtProStructures::readFont(), ClarisWksStyleManager::readFontAndPos(), MarinerWrtText::readFonts(), LightWayTxtText::readFonts(), NisusWrtText::readFonts(), RagTimeText::readFonts(), MacDrawProStyleManager::readFontStyles(), StyleParser::readFormats(), MsWksDBParser::readForms(), MsWksDBParser::readFormTypes(), MoreText::readOutline(), PowerPoint3Parser::readParagraph(), ClarisWksDbaseContent::readRecordSSV1(), MsWksDBParser::readReportHeader(), ZWrtText::readSectionFonts(), SuperPaintParser::readShape(), WingzParser::readSpreadsheetStyle(), BeagleWksDRParser::readStyle(), GreatWksSSParser::readStyles(), DocMkrText::readStyles(), MaxWrtParser::readStyles(), TeachTxtParser::readStyles(), StyleParser::readStyleTable(), MsWksTable::readTable(), MacDraft5Parser::readText(), PowerPoint7Text::readTextZone(), WingzGraph::readTextZone(), FullWrtText::send(), DrawTableParser::sendShape(), GreatWksText::sendSimpleTextbox(), CanvasGraph::sendText(), CricketDrawParser::sendText(), CorelPainterParser::sendText(), MoreText::sendText(), PowerPoint1Parser::sendText(), StudentWritingCParser::sendText(), FullWrtTextInternal::Font::update(), and RagTime5StyleManager::updateTextStyles().

## ◆ setDeltaLetterSpacing()

void MWAWFont::setDeltaLetterSpacing | ( | float | d,
|  | librevenge::RVNGUnit | unit = `librevenge::RVNG_POINT`
| ) |  |
| inline

sets the letter spacing ( delta value in point )

Referenced by RagTimeText::readCharProperties(), Canvas5StyleManager::readCharStyle(), LightWayTxtText::readDocumentHF(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrdTextStyles::readFont(), MacDocParser::readFont(), GreatWksText::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MsWks4Text::readFont(), MacWrtProStructures::readFont(), ClarisWksStyleManager::readFontAndPos(), MarinerWrtText::readFonts(), LightWayTxtText::readFonts(), NisusWrtText::readFonts(), RagTimeText::readFonts(), StyleParser::readFormats(), MacDrawParser::readObject(), ClarisWksDbaseContent::readRecordSSV1(), RagTimeSpreadsheet::readResource(), RagTimeSpreadsheet::readSpreadsheetCellV2(), Canvas5StyleManager::readStyleEnd(), GreatWksSSParser::readStyles(), MaxWrtParser::readStyles(), TeachTxtParser::readStyles(), StyleParser::readStyleTable(), FullWrtText::send(), GreatWksText::sendSimpleTextbox(), CanvasGraph::sendText(), and RagTime5StyleManager::updateTextStyles().

## ◆ setFlags()

void MWAWFont::setFlags | ( | uint32_t | fl | ) |
| inline

sets the font attributes bold, ...

Referenced by BeagleWksTextInternal::Font::getFont(), insert(), LightWayTxtTextInternal::Font::merge(), JazzSSParser::readCell(), MsWksSSParser::readCell(), BeagleWksSSParser::readCellSheet(), RagTimeText::readCharProperties(), Canvas5StyleManager::readCharStyle(), MoreText::readCustomListLevel(), JazzSSParser::readDocument(), LightWayTxtText::readDocumentHF(), MsWksDBParser::readFieldTypes(), MsWksDBParser::readFieldTypesV2(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrd1Parser::readFont(), WordMakerParser::readFont(), MsWks3Text::readFont(), MsWrdTextStyles::readFont(), MacDocParser::readFont(), GreatWksText::readFont(), MsWksGraph::readFont(), ActaText::readFont(), MouseWrtParser::readFont(), PowerPoint3Parser::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MsWks4Text::readFont(), MacWrtProStructures::readFont(), LightWayTxtText::readFont2(), ClarisWksStyleManager::readFontAndPos(), WriterPlsParser::readFonts(), MarinerWrtText::readFonts(), LightWayTxtText::readFonts(), NisusWrtText::readFonts(), PowerPoint1Parser::readFonts(), MindWrtParser::readFonts(), RagTimeText::readFonts(), MacDrawProStyleManager::readFontStyles(), BeagleWksDBParser::readFormat(), StyleParser::readFormats(), MsWksDBParser::readFormTypes(), ActaParser::readHFProperties(), MacWrtParser::readInformations(), MacDraftParser::readLabel(), MacDraftParser::readObject(), MacDrawParser::readObject(), MoreText::readOutline(), ClarisWksDbaseContent::readRecordSSV1(), MsWksDBParser::readReportHeader(), ZWrtText::readSectionFonts(), SuperPaintParser::readShape(), RagTimeSpreadsheet::readSpreadsheetCellV2(), WingzParser::readSpreadsheetStyle(), BeagleWksDRParser::readStyle(), GreatWksSSParser::readStyles(), DocMkrText::readStyles(), MaxWrtParser::readStyles(), TeachTxtParser::readStyles(), StyleParser::readStyleTable(), MsWksTable::readTable(), MacDraft5Parser::readText(), MacWrtParser::readText(), FreeHandParser::readTextboxV1(), FreeHandParser::readTextboxV2(), PowerPoint7Text::readTextZone(), WingzGraph::readTextZone(), FullWrtText::send(), Canvas5Graph::sendDimension9(), EDocParser::sendIndex(), JazzWriterParser::sendPLC(), DrawTableParser::sendShape(), GreatWksText::sendSimpleTextbox(), CanvasGraph::sendText(), CorelPainterParser::sendText(), MoreText::sendText(), PowerPoint1Parser::sendText(), StudentWritingCParser::sendText(), DocMkrText::sendTOC(), MsWrdStruct::Font::updateFontToFinalState(), and RagTime5StyleManager::updateTextStyles().

## ◆ setFont()

void MWAWFont::setFont | ( | int | newId | ) |
| inline

sets the font id and resets size to the previous size for this font

Referenced by MsWksGraph::readFont(), BeagleWksDRParser::sendText(), SuperPaintParser::sendText(), and MacDrawProParser::sendText().

## ◆ setId()

void MWAWFont::setId | ( | int | newId | ) |
| inline

sets the font id

Referenced by BeagleWksText::getFont(), MarinerWrtTextInternal::Zone::getFont(), MsWrdTextStyles::getFont(), BeagleWksSSParser::readCellSheet(), RagTimeText::readCharProperties(), Canvas5StyleManager::readCharStyle(), MoreText::readCustomListLevel(), JazzSSParser::readDocument(), LightWayTxtText::readDocumentHF(), MsWksDBParser::readFieldTypes(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrd1Parser::readFont(), WordMakerParser::readFont(), MsWks3Text::readFont(), MsWrdTextStyles::readFont(), MacDocParser::readFont(), GreatWksText::readFont(), ActaText::readFont(), MouseWrtParser::readFont(), PowerPoint3Parser::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MsWks4Text::readFont(), MacWrtProStructures::readFont(), ClarisWksStyleManager::readFontAndPos(), WriterPlsParser::readFonts(), LightWayTxtText::readFonts(), NisusWrtText::readFonts(), PowerPoint1Parser::readFonts(), MindWrtParser::readFonts(), RagTimeText::readFonts(), MacDrawProStyleManager::readFontStyles(), DocMkrText::readFooter(), BeagleWksDBParser::readFormat(), StyleParser::readFormats(), MsWksDBParser::readForms(), MsWksDBParser::readFormTypes(), ActaParser::readHFProperties(), MacWrtParser::readInformations(), MacDraftParser::readLabel(), FullWrtText::readLineHeader(), MacDraftParser::readObject(), MacDrawParser::readObject(), MoreText::readOutline(), PowerPoint3Parser::readParagraph(), ClarisWksDbaseContent::readRecordSSV1(), MsWksDBParser::readReportHeader(), MarinerWrtText::readRulers(), ZWrtText::readSectionFonts(), SuperPaintParser::readShape(), RagTimeSpreadsheet::readSpreadsheetCellV2(), WingzParser::readSpreadsheetStyle(), BeagleWksDRParser::readStyle(), GreatWksSSParser::readStyles(), DocMkrText::readStyles(), MaxWrtParser::readStyles(), TeachTxtParser::readStyles(), StyleParser::readStyleTable(), MacDraft5Parser::readText(), MacWrtParser::readText(), MsWks4Text::readText(), PowerPoint7Text::readTextZone(), WingzGraph::readTextZone(), MsWksDBParser::readUnknownV2(), FullWrtText::send(), Canvas5Graph::sendDimension9(), FullWrtText::sendHiddenItem(), JazzWriterParser::sendPLC(), DrawTableParser::sendShape(), GreatWksText::sendSimpleTextbox(), CanvasGraph::sendText(), PowerPoint7Text::sendText(), CorelPainterParser::sendText(), MoreText::sendText(), PowerPoint1Parser::sendText(), StudentWritingCParser::sendText(), MWAWGraphicListener::setFont(), MWAWPresentationListener::setFont(), MWAWSpreadsheetListener::setFont(), MWAWTextListener::setFont(), MsWrdTextStyles::setProperty(), and RagTime5StyleManager::updateTextStyles().

## ◆ setLanguage()

void MWAWFont::setLanguage | ( | std::string const & | lang | ) |
| inline

set the language ( in the for en_US, en_GB, en, ...)

Referenced by MacWrtProStructures::readFont(), RagTimeText::readFonts(), and RagTime5StyleManager::updateTextStyles().

## ◆ setOverline()

void MWAWFont::setOverline | ( | Line const & | line | ) |
| inline

sets the overline

Referenced by LightWayTxtTextInternal::Font::merge(), and MarinerWrtText::readFonts().

## ◆ setOverlineColor()

void MWAWFont::setOverlineColor | ( | MWAWColor const & | color | ) |
| inline

sets the overline color

Referenced by LightWayTxtText::readFont2().

## ◆ setOverlineStyle()

void MWAWFont::setOverlineStyle | ( | Line::Style | style = `Line::None`,
|  | bool | doReset = `true`
| ) |  |
| inline

sets the overline style ( by default, we also reset the style)

Referenced by HanMacWrdKText::readFont(), HanMacWrdJText::readFont(), LightWayTxtText::readFont2(), NisusWrtText::readFonts(), and FullWrtText::send().

## ◆ setOverlineType()

void MWAWFont::setOverlineType | ( | Line::Type | type = `Line::Single` | ) |
| inline

sets the overline type

Referenced by LightWayTxtText::readFont2().

## ◆ setOverlineWidth()

void MWAWFont::setOverlineWidth | ( | float | w | ) |
| inline

sets the overline width

Referenced by HanMacWrdKText::readFont(), HanMacWrdJText::readFont(), and LightWayTxtText::readFont2().

## ◆ setOverlineWordFlag()

void MWAWFont::setOverlineWordFlag | ( | bool | wordFlag = `false` | ) |
| inline

sets the overline word flag

## ◆ setSize()

void MWAWFont::setSize | ( | float | sz,
|  | bool | isRelative = `false`
| ) |  |
| inline

sets the font size

Referenced by MsWrdTextStyles::getFont(), BeagleWksSSParser::readCellSheet(), RagTimeText::readCharProperties(), Canvas5StyleManager::readCharStyle(), MoreText::readCustomListLevel(), JazzSSParser::readDocument(), LightWayTxtText::readDocumentHF(), MsWksDBParser::readFieldTypes(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrd1Parser::readFont(), WordMakerParser::readFont(), MsWks3Text::readFont(), MsWrdTextStyles::readFont(), MacDocParser::readFont(), GreatWksText::readFont(), MsWksGraph::readFont(), ActaText::readFont(), MouseWrtParser::readFont(), PowerPoint3Parser::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MsWks4Text::readFont(), MacWrtProStructures::readFont(), ClarisWksStyleManager::readFontAndPos(), WriterPlsParser::readFonts(), MarinerWrtText::readFonts(), LightWayTxtText::readFonts(), NisusWrtText::readFonts(), PowerPoint1Parser::readFonts(), MindWrtParser::readFonts(), RagTimeText::readFonts(), MacDrawProStyleManager::readFontStyles(), DocMkrText::readFooter(), BeagleWksDBParser::readFormat(), StyleParser::readFormats(), MsWksDBParser::readForms(), MsWksDBParser::readFormTypes(), ActaParser::readHFProperties(), MacWrtParser::readInformations(), MacDraftParser::readLabel(), FullWrtText::readLineHeader(), MacDraftParser::readObject(), MacDrawParser::readObject(), MoreText::readOutline(), PowerPoint3Parser::readParagraph(), ClarisWksDbaseContent::readRecordSSV1(), MsWksDBParser::readReportHeader(), MarinerWrtText::readRulers(), ZWrtText::readSectionFonts(), SuperPaintParser::readShape(), RagTimeSpreadsheet::readSpreadsheetCellV2(), WingzParser::readSpreadsheetStyle(), BeagleWksDRParser::readStyle(), GreatWksSSParser::readStyles(), DocMkrText::readStyles(), MaxWrtParser::readStyles(), TeachTxtParser::readStyles(), StyleParser::readStyleTable(), MacDraft5Parser::readText(), MacWrtParser::readText(), FreeHandParser::readTextboxV1(), FreeHandParser::readTextboxV2(), PowerPoint7Text::readTextZone(), WingzGraph::readTextZone(), MsWksDBParser::readUnknownV2(), FullWrtText::send(), Canvas5Graph::sendDimension9(), FullWrtText::sendHiddenItem(), JazzWriterParser::sendPLC(), DrawTableParser::sendShape(), GreatWksText::sendSimpleTextbox(), CanvasGraph::sendText(), CorelPainterParser::sendText(), MoreText::sendText(), PowerPoint1Parser::sendText(), StudentWritingCParser::sendText(), MWAWGraphicListener::setFont(), MWAWPresentationListener::setFont(), MWAWSpreadsheetListener::setFont(), MWAWTextListener::setFont(), MsWrdTextStyles::setProperty(), and RagTime5StyleManager::updateTextStyles().

## ◆ setStrikeOut()

void MWAWFont::setStrikeOut | ( | Line const & | line | ) |
| inline

sets the strikeoutline

Referenced by LightWayTxtTextInternal::Font::merge().

## ◆ setStrikeOutColor()

void MWAWFont::setStrikeOutColor | ( | MWAWColor const & | color | ) |
| inline

sets the strikeoutline color

Referenced by LightWayTxtText::readFont2().

## ◆ setStrikeOutStyle()

void MWAWFont::setStrikeOutStyle | ( | Line::Style | style = `Line::None`,
|  | bool | doReset = `true`
| ) |  |
| inline

sets the strikeoutline style ( by default, we also reset the style)

Referenced by Canvas5StyleManager::readCharStyle(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrdTextStyles::readFont(), GreatWksText::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MacWrtProStructures::readFont(), LightWayTxtText::readFont2(), ClarisWksStyleManager::readFontAndPos(), MarinerWrtText::readFonts(), NisusWrtText::readFonts(), StyleParser::readFormats(), ClarisWksDbaseContent::readRecordSSV1(), GreatWksSSParser::readStyles(), FullWrtText::send(), Canvas5Graph::sendDimension9(), GreatWksText::sendSimpleTextbox(), MsWrdStruct::Font::updateFontToFinalState(), and RagTime5StyleManager::updateTextStyles().

## ◆ setStrikeOutType()

void MWAWFont::setStrikeOutType | ( | Line::Type | type = `Line::Single` | ) |
| inline

sets the strikeoutline type

Referenced by HanMacWrdKText::readFont(), HanMacWrdJText::readFont(), and LightWayTxtText::readFont2().

## ◆ setStrikeOutWidth()

void MWAWFont::setStrikeOutWidth | ( | float | w | ) |
| inline

sets the strikeoutline width

Referenced by LightWayTxtText::readFont2().

## ◆ setStrikeOutWordFlag()

void MWAWFont::setStrikeOutWordFlag | ( | bool | wordFlag = `false` | ) |
| inline

sets the strikeoutline word flag

## ◆ setUnderline()

void MWAWFont::setUnderline | ( | Line const & | line | ) |
| inline

sets the underline

Referenced by LightWayTxtTextInternal::Font::merge(), MarinerWrtText::readFonts(), and RagTime5StyleManager::updateTextStyles().

## ◆ setUnderlineColor()

void MWAWFont::setUnderlineColor | ( | MWAWColor const & | color | ) |
| inline

sets the underline color

Referenced by WriteNowText::readFont(), and LightWayTxtText::readFont2().

## ◆ setUnderlineStyle()

void MWAWFont::setUnderlineStyle | ( | Line::Style | style = `Line::None`,
|  | bool | doReset = `true`
| ) |  |
| inline

sets the underline style ( by default, we also reset the style)

Referenced by BeagleWksTextInternal::Font::getFont(), MsWksSSParser::readCell(), BeagleWksSSParser::readCellSheet(), RagTimeText::readCharProperties(), Canvas5StyleManager::readCharStyle(), MoreText::readCustomListLevel(), JazzSSParser::readDocument(), LightWayTxtText::readDocumentHF(), MsWksDBParser::readFieldTypes(), MsWksDBParser::readFieldTypesV2(), HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrd1Parser::readFont(), WordMakerParser::readFont(), MsWks3Text::readFont(), MsWrdTextStyles::readFont(), MacDocParser::readFont(), GreatWksText::readFont(), MsWksGraph::readFont(), ActaText::readFont(), MouseWrtParser::readFont(), PowerPoint3Parser::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MsWks4Text::readFont(), MacWrtProStructures::readFont(), LightWayTxtText::readFont2(), ClarisWksStyleManager::readFontAndPos(), WriterPlsParser::readFonts(), MarinerWrtText::readFonts(), LightWayTxtText::readFonts(), NisusWrtText::readFonts(), PowerPoint1Parser::readFonts(), MindWrtParser::readFonts(), RagTimeText::readFonts(), MacDrawProStyleManager::readFontStyles(), BeagleWksDBParser::readFormat(), StyleParser::readFormats(), MsWksDBParser::readFormTypes(), ActaParser::readHFProperties(), MacWrtParser::readInformations(), MacDraftParser::readLabel(), MacDraftParser::readObject(), MacDrawParser::readObject(), MoreText::readOutline(), ClarisWksDbaseContent::readRecordSSV1(), MsWksDBParser::readReportHeader(), ZWrtText::readSectionFonts(), SuperPaintParser::readShape(), RagTimeSpreadsheet::readSpreadsheetCellV2(), WingzParser::readSpreadsheetStyle(), BeagleWksDRParser::readStyle(), GreatWksSSParser::readStyles(), DocMkrText::readStyles(), MaxWrtParser::readStyles(), TeachTxtParser::readStyles(), StyleParser::readStyleTable(), MsWksTable::readTable(), MacDraft5Parser::readText(), MacWrtParser::readText(), PowerPoint7Text::readTextZone(), WingzGraph::readTextZone(), FullWrtText::send(), Canvas5Graph::sendDimension9(), JazzWriterParser::sendPLC(), DrawTableParser::sendShape(), GreatWksText::sendSimpleTextbox(), CanvasGraph::sendText(), MoreText::sendText(), PowerPoint1Parser::sendText(), StudentWritingCParser::sendText(), MsWrdStruct::Font::updateFontToFinalState(), and RagTime5StyleManager::updateTextStyles().

## ◆ setUnderlineType()

void MWAWFont::setUnderlineType | ( | Line::Type | type = `Line::Single` | ) |
| inline

sets the underline type

Referenced by HanMacWrdKText::readFont(), ClarisDrawText::readFont(), ClarisWksStyleManager::readFont(), MsWrdTextStyles::readFont(), GreatWksText::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MacWrtProStructures::readFont(), LightWayTxtText::readFont2(), ClarisWksStyleManager::readFontAndPos(), MarinerWrtText::readFonts(), GreatWksSSParser::readStyles(), FullWrtText::send(), and GreatWksText::sendSimpleTextbox().

## ◆ setUnderlineWidth()

void MWAWFont::setUnderlineWidth | ( | float | w | ) |
| inline

sets the underline width

Referenced by HanMacWrdKText::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), and LightWayTxtText::readFont2().

## ◆ setUnderlineWordFlag()

void MWAWFont::setUnderlineWordFlag | ( | bool | wordFlag = `false` | ) |
| inline

sets the underline word flag

Referenced by MsWrdTextStyles::readFont(), MarinerWrtText::readFonts(), NisusWrtText::readFonts(), and FullWrtText::send().

## ◆ setWidthStreching()

void MWAWFont::setWidthStreching | ( | float | scale = `1.0` | ) |
| inline

sets the text width streching

Referenced by Canvas5StyleManager::readCharStyle(), HanMacWrdKText::readFont(), HanMacWrdJText::readFont(), and RagTime5StyleManager::updateTextStyles().

## ◆ size()

float MWAWFont::size | ( |  | ) | const
| inline

returns the font size

Referenced by addTo(), addToListLevel(), cmp(), getDebugString(), MsWrdTextStyles::getFont(), Canvas5StyleManager::readCharStyle(), HanMacWrdKText::readFont(), HanMacWrdJText::readFont(), MacWrtProStructures::readFont(), LightWayTxtText::readFonts(), ZWrtText::readSectionFonts(), FullWrtText::send(), MarinerWrtGraph::sendRule(), MoreText::sendText(), MWAWGraphicListener::setFont(), MWAWPresentationListener::setFont(), MWAWSpreadsheetListener::setFont(), MWAWTextListener::setFont(), and MsWrdTextStyles::setProperty().

## ◆ widthStreching()

float MWAWFont::widthStreching | ( |  | ) | const
| inline

returns the text width streching

## Member Data Documentation

## ◆ m_backgroundColor

MWAWVariable<MWAWColor> MWAWFont::m_backgroundColor
| protected

font background color

Referenced by addTo(), cmp(), getBackgroundColor(), getDebugString(), insert(), resetColor(), and setBackgroundColor().

## ◆ m_color

MWAWVariable<MWAWColor> MWAWFont::m_color
| protected

font color

Referenced by addTo(), addToListLevel(), cmp(), getColor(), getDebugString(), hasColor(), insert(), resetColor(), and setColor().

## ◆ m_deltaSpacing

MWAWVariable<float> MWAWFont::m_deltaSpacing
| protected

expand(> 0), condensed(< 0) depl

Referenced by addTo(), cmp(), deltaLetterSpacing(), getDebugString(), insert(), and setDeltaLetterSpacing().

## ◆ m_deltaSpacingUnit

MWAWVariable<librevenge::RVNGUnit> MWAWFont::m_deltaSpacingUnit
| protected

the delta spacing unit

Referenced by addTo(), cmp(), deltaLetterSpacingUnit(), getDebugString(), insert(), and setDeltaLetterSpacing().

## ◆ m_extra

std::string MWAWFont::m_extra

extra data

Referenced by getDebugString(), insert(), LightWayTxtTextInternal::Font::merge(), HanMacWrdKText::readFont(), MacDocParser::readFont(), GreatWksText::readFont(), MsWksGraph::readFont(), ActaText::readFont(), MouseWrtParser::readFont(), PowerPoint3Parser::readFont(), HanMacWrdJText::readFont(), WriteNowText::readFont(), MacWrtProStructures::readFont(), LightWayTxtText::readFont2(), WriterPlsParser::readFonts(), LightWayTxtText::readFonts(), MacDrawProStyleManager::readFontStyles(), RagTimeSpreadsheet::readResource(), DocMkrText::readStyles(), TeachTxtParser::readStyles(), and StyleParser::readStyleTable().

## ◆ m_flags

MWAWVariable<uint32_t> MWAWFont::m_flags
| protected

font attributes

Referenced by addTo(), flags(), getDebugString(), insert(), and setFlags().

## ◆ m_id

MWAWVariable<int> MWAWFont::m_id
| protected

font identificator

Referenced by addToListLevel(), id(), insert(), isSet(), setFont(), and setId().

## ◆ m_language

MWAWVariable<std::string> MWAWFont::m_language
| protected

the language if set

Referenced by addTo(), cmp(), getDebugString(), language(), and setLanguage().

## ◆ m_overline

MWAWVariable<Line> MWAWFont::m_overline
| protected

overline attributes

Referenced by addTo(), cmp(), getDebugString(), getOverline(), hasDecorationLines(), insert(), resetDecorationLines(), setOverline(), setOverlineColor(), setOverlineStyle(), setOverlineType(), setOverlineWidth(), and setOverlineWordFlag().

## ◆ m_scriptPosition

MWAWVariable<Script> MWAWFont::m_scriptPosition
| protected

the sub/super script definition

Referenced by addTo(), getDebugString(), insert(), script(), and set().

## ◆ m_size

MWAWVariable<float> MWAWFont::m_size
| protected

font size

Referenced by addToListLevel(), insert(), setSize(), and size().

## ◆ m_sizeIsRelative

MWAWVariable<bool> MWAWFont::m_sizeIsRelative
| protected

true if the size is percent

Referenced by addTo(), addToListLevel(), cmp(), getDebugString(), insert(), and setSize().

## ◆ m_strikeoutline

MWAWVariable<Line> MWAWFont::m_strikeoutline
| protected

overline attributes

Referenced by addTo(), cmp(), getDebugString(), getStrikeOut(), hasDecorationLines(), insert(), resetDecorationLines(), setStrikeOut(), setStrikeOutColor(), setStrikeOutStyle(), setStrikeOutType(), setStrikeOutWidth(), and setStrikeOutWordFlag().

## ◆ m_underline

MWAWVariable<Line> MWAWFont::m_underline
| protected

underline attributes

Referenced by addTo(), cmp(), getDebugString(), getUnderline(), hasDecorationLines(), insert(), resetDecorationLines(), setUnderline(), setUnderlineColor(), setUnderlineStyle(), setUnderlineType(), setUnderlineWidth(), and setUnderlineWordFlag().

## ◆ m_widthStreching

MWAWVariable<float> MWAWFont::m_widthStreching
| protected

the width streching in percent

Referenced by addTo(), cmp(), getDebugString(), insert(), setWidthStreching(), and widthStreching().

The documentation for this class was generated from the following files:

- MWAWFont.hxx
- MWAWFont.cxx